PicWalker

Home Page
PicWalker is a fast, easy to use image viewer/editor/converter for Windows.

Unlike conventional viewers that display one image at a time, it lets you see multiple images at once with its continuous pages option.
You can browse images in directories or in archived files. This program will remember the last file you opened in each directory and many other things, so you can get back to where you were quickly.

There are several modes you can try, and many aspects of the program can be adjusted via the option dialog.

You can also do batch conversion and create plug-ins to extend the program's functionality.

If you have something that you want to see added, just sent me an email.
Some of the features in PicWalker came from the suggestions of other users, just like yourself.

Enjoy!


 Getting started
When you start the application for the first time, you will be presented with an intro screen.
This screen will also show you the different shortcuts that have been set.

At this point you can type the directory to browse in the address bar.
You can also use the File menu, toolbar button or drag and drop.
Just drop a file or a directory on the main window to open it.

During the open file process, if the control key is held down, the program will include the content of sub-directories.

For more information on part of the program's toolbar, click the area below.

The drop down list next to the address bar will be filled with the list of files.
If a compressed file is opened, the content is displayed in the secondary toolbar's drop down.

Once a file is opened, you can scroll around using the mouse or the arrow keys.

Initially the edit functions are hidden. To access them, use the Edit image command from the Edit menu.

The toolbars and extra windows can be docked or set as floating window. To move a window, click on the title bar or the left side of a toolbar, and drag it. Hold down the control key while moving the window to prevent docking.


 Supported Formats
Archived files
PicWalker is able to display images stored in the following archive file formats:
ACE, CAB, RAR, TAR, ZIP

For TAR and ZIP formats, the program will decompress files with size less than 1 MB to memory for faster access. Therefore it is recommended to use those formats.
Picture files
Name | Extension | Read | Write
Adobe Photoshop | .psd | Yes |
Compuserve GIF | .gif | Yes | Yes
Enhanced Metafile Format | .emf | Yes |
Interleaved Bitmap | .ilbm | Yes | Yes
JPEG | .jpe;jpg | Yes | Yes
Portable Bitmap | .pbm | Yes | Yes
Portable Graymap | .pgm | Yes | Yes
Portable Network Graphics | .png | Yes | Yes
Portable Pixmap | .ppm | Yes | Yes
Silicon Graphics RGB | .rgb;.sgi | Yes | Yes
Sun Raster file | .ras | Yes | Yes
Truevision Targa | .tga | Yes | Yes
Tagged Image File Format | .tif | Yes |
Windows Bitmap | .bmp | Yes | Yes
Windows Icon | .ico | Yes |
Windows Metafile Format | .wmf | Yes |
Wireless Bitmap | .wbmp | Yes | Yes
X11 Bitmap | .xbm |  | Yes
X11 Pixmap | .xpm |  | Yes
Zsoft Paintbrush | .pcx | Yes | Yes
Save Options
JPEG format
This is the most popular format used to store full color images. It uses a lossy compression, which means the image will not be the same once it is encoded as JPEG.
You can adjust the quality of output. The default quality is 75.
You can also save it as gray scale image.
PS: If you do not save it as gray scale, the image will be converted to 24 bit, even if it only uses 1 bit.

PNG format (Portable Network Graphics)
This format was created to replace GIF as a standard in the web. The compression rate is lower than JPEG, but it uses lossless compression, which means the image stays the same after it is encoded.
You can adjust the compression level (default to 6). The higher level requires more time to compress.
You can also select the filter manually to get better compression rate. The default filter for 24 bit images is the paeth filter.
For more info on PNG filtering, please check http://www.libpng.org/pub/png/spec/1.2/PNG-Filters.html


 File Menu
Open file | Brings up the open file dialog where you can select an image file to be displayed in PicWalker
Save as | Save current image in the current directory
Save in previous folder | Same as Save as command, but the directory is set to previously used save directory
Delete current file |
Print | Print current image. If the application is not in edit mode, you can also select the pages to be printed
Select source | Open the dialog to select a twain source
Acquire | Open the scan dialog using current twain source
Exit | Exit PicWalker and save all current settings.


 Edit Menu
Edit Image | Start editing an image. The second toolbar will be shown, and the edit commands will be enabled
Undo | Undo the last edit command performed on the image
Redo | Redo the command previously undone
Repeat last command | Repeat previous edit command
Copy | Copy current image to the clipboard. If a selection exists, only the selected part of the image will be copied
Paste | Paste bitmap clipboard content and start the edit mode.


 View Menu
Toolbar | Show/hide the main toolbar
Secondary toolbar | Show the toolbar with alignment icons and the file list for archive file content. The toolbar is also used in edit mode
Auto scroll down | Continuously scroll the view down. Only available if continuous pages mode is turned on
Auto scroll up | Continuously scroll the view up
Zoom in | Shrink the image
Zoom out | Make the image larger
Normal size | Reset the zoom to 100%
Fit to width | Resize each image to fit in the window horizontally, can be combined with Fit to height and zoom commands
Fit to height | Resize each image to fit in the window vertically
Align left/center/right | Sets the alignment for images. When used with continuous pages horizontal mode, right align will reverse the ordering of the pages.
Explorer view | Toggle explorer view
File list | Display a window that lists all the images in the file list drop down
Directory tree | Show the directory tree to navigate to different folder
Continuous pages | Display images before and after the current image continuously
Continuous pages horz | Same as above, but the images are placed horizontally
Full screen | Toggle full screen mode


 Favorite Menu
Add to favorites | Add current directory to favorite. You can assign a label for this favorite item
Organize favorites | Modify/delete content of favorites


 Tools Menu
Options | Shows a dialog to customize the application to suit your preferences
Slide show | Start/stop slide show
Slide show options | Change the slide show behavior. You can change the sort order, fitting, speed and transition effect
Extract archive file | Copy content of the current archive file to a directory
Batch convert | Convert all or some of the images in the list to another format. You can also apply image manipulation functions such as resize and decrease color depth prior to saving
Set as wallpaper | Set current image as the wallpaper of your windows desktop
Search duplicate files | Look for duplicate files in a directory or across several directories
Clear recent directories history | Remove all the entries from the address drop down list
Export toolbar images | Export the bitmaps used for toolbar, so you can modify it
Random jump to a page | Randomly select and open a picture from the list


 Tools -> Options
The first tab displays the general preferences.

By default the program displays an intro screen at startup if no other parameter is given.
You can change it to open the last file from previous session.
PicWalker remembers the last opened file in each directory, up to 500 directories, and up to 2000 archive files.

When you drag an image, the program default behavior is to scroll down as you move the mouse down.
If you prefer the opposite, you can check the Reverse image drag direction check box.

The second check box is to let the program know if you prefer to enlarge small image when using the Fit width/height command.

Show directory structure of archive
Using this option, you can tell the program to either preserve the directory structure in archive files, or to collapse them to a single list.

Do not show archive content in explorer view
Normally double clicking an archive file in explorer view will show the contents of the archive, and then double clicking a picture file in it will display the picture.
By enabling this option, the program will bypass the first step, and display the first file in the archive.
This option does not work when the archive has other archives in it, or when you hold down the control key.

The tooltip in edit mode will show you the cursor position and the color at that position. Check the fifth check box if you want to see it.

The last check box can be unchecked, if you want to open a new window whenever PicWalker is run.
You can always hold down Shift key when starting the application if you want to open a new window.
The second tab in the Options dialog, allows you to set shortcut keys to all the menu options.

Keys that cannot be used as shortcuts are: Escape, Enter, Tab, Alt, PrintScreen and the arrow keys.
To change a shortcut, click on the desired menu option, and press the new key.

The third tab allows you to set mouse shortcut to some of the menu options.
The left button is reserved for dragging and to be used in combination with other buttons.

The fourth tab can be used to associate some file extensions with PicWalker, so it opens automatically when you double-click it in explorer.

Custom filter allows you to add new file extensions to be recognized by the application.
PicWalker only includes files with these extensions in its file lists.

Additionally, you can also create/remove desktop and SendTo shortcuts.

The fifth tab is for scrolling option.

The first scroll speed is for when you use the arrow keys to scroll around.

The second scroll speed is used when you enable the Automatic scroll mode.

The timer interval is the number of times that the program scrolls in one second. Default is 200 (max), and you can lower it to slow down overall scrolling speed.

Check the first check box to start auto scroll using mouse wheel.

If you prefer to see the scroll bar in the view window, you can set it here.
The last tab gives you access to advanced options.

Check the "do not load built-in codecs" if you are a developer that wants to test your own codecs.

If you prefer the Apply button as default button in edit dialog boxes, check the second option.
A default button is the button that is clicked when you press the Enter key. It is useful when you need to try out the different options quickly.

If you do not want the application to keep track of the directories you browse, check the third check box.

If you want the program to remember alignment setting per directory and archive file, check the fourth check box. The default is to use one global alignment setting.

The fifth option can be used to speed up thumbnail creation. Normally, thumbnail is created on demand while in explorer view. Enabling this option will make the program generate thumbnail everytime an image is loaded when you are viewing it, so the program does not need to reload the image when you switch to explorer view.

You can also set the resampling filter for zooming in/out operation. Please note that some of the filters (e.g., lanczos) use a lot of computation, and you should only use it if you have a fast enough computer.
The resampling is done only on the parts of image that needs to be drawn.

Finally, you can also change the memory size for Undo operation, if you feel it is not enough or too much. The application will always allow one undo, regardless of the undo size.


 Tools -> Slide Show Options

This dialog allows you to customize the slide show. You can change the sort order, starting and end pages.
The delay time is measured in second. You can set the slide show to loop forever, it can always be stopped by pressing the escape key or the shortcut key for slide show.

Currently there are 7 effects you can choose from:
Vertical up / down, horizontal left / right, zoom in / out and blend.
You can also choose random, to let the program randomly select a transition effect when it opens the next file.
The transition speed can also be adjusted.

Your display needs to have 16 bits color or above in order to use the transition effect.


 Modifying toolbar icons
You can modify the icons used by the toolbars by first exporting the toolbar bitmaps.

The program will create 2 files in the same directory as the program file, that you can modify to use your own icons: toolbar8.png and toolbar4.png.

toolbar8.png is used when your display mode is 16 bit colors or more, you can make it use 256 colors or more.
toolbar4.png is used when the display mode is 256 colors or less, to avoid interference with the image's color palette you should make it have 16 colors at most.
Each icon must be the same size, and the top left pixel is used to determine the transparent color.


 Help Menu
Help contents | Display this help file
Enter registration info | Registration will help the development of this program. To register, please visit http://www.oma-penny.com. Once you registered, you can enter the information using this menu
Usage info | Display usage agreement dialog
About | Display program's info dialog


 Image Menu
Flip horizontal | Turn the image upside down
Flip vertical | Mirror the image
Rotate left | Rotate image 90 degree to the left
Rotate right | Rotate image 90 degree to the right
Resample | Resize the image using a resampling filter. Several filters are available to choose from
Blur/sharpen | Make the image appear more blurry or sharper
Edge detection | Trace the edges of the image. You can choose from 3 different methods


 Color Menu
Adjust color | Change color balance, brightness, contrast and gamma
Negative | Reverse all the colors
Decrease BPP | Reduce the number of colors used. You can use one of 3 methods available: Octree, Neural-Net and Wu, in conjunction with using error diffusion
Increase BPP | Increase the number of bits used for each color. It does not change the image appearance, and will increase the size required to store the image
Gray scale | Change the image to an 8 bit gray scale image
Dither | Convert the image to black & white, 4 methods to choose from
Swap RGB | Swap the red, green and blue color components


 Insert Menu
Paste to left This menu can be used to combine images, by appending clipboard bitmap content to the current image
Paste to right
Paste above
Paste below


 Plug-ins Menu
This menu is only enabled when there is a PicWalker's image manipulation plug-in installed in your computer. Plug-ins should be placed in \plugins directory within the directory where the executable is.
This menu will list the names of each plug-in function available.


 Navigation
The toolbar allows you to browse the file list easily. You can access most recently used directories, and jump from file to file easily using it.

You can drag & drop a file/directory on the application window to open it.
Once a file is opened, you can open the other files that are listed in the file list using various methods:
1. Using the file list drop down
2. Using navigation buttons
3. Using keyboard/mouse shortcuts
4. Use the context menu by right clicking as shown below.

The next/previous archive option is only available when you are viewing an archive file (zip/rar).
Continuous pages option is not available in edit mode.

Most of the context menu options are also available from the View menus.

Scrolling
You can drag an image by holding down the left button while moving the mouse.
As you move the mouse, the cursor position is returned to the original location to minimize your movement effort.
Both the speed and drag direction can be changed from Options menu.

"Lock mouse drag" is a feature that when enabled allows you to maintain dragging without holding down the left mouse button.
You may want to try assigning it to double-click shortcut.

Alternatively, you can use the arrow keys to move around.
Auto Scroll
This option is only available in continuous pages mode. It continuously scrolls the image up/down or left/right.
The speed can be adjusted from the option dialog.
When the option to use mouse wheel to start auto scroll is enabled, you can use the wheel to adjust the scrolling speed or to change direction as well.


 Editing
PicWalker includes a number of image manipulation routines. To use it, select "Edit image" option from the Edit menu. It is also activated by pasting an image from the clipboard.

In edit mode, the continuous pages options are not available.
The Undo and Redo commands are available while editing. You can change the memory size available for undo from the advanced option dialog.
There is also an option in the general option tab to display an info tooltip while in edit mode.
Printing in edit mode is limited to the current image.

P.S.: Undo is automatically cleared when you open another file.

This is a typical edit dialog box. Click on the area you want to know about to get the description.


 Adjust Color

In this dialog you can adjust brightness, contrast, gamma and color balance.
As you move the sliders, the preview window gives you a sample of how the output will look like.
You can click the Apply button to see the change applied to the original image.
Undo can always be used to get back to the original image.
To reset the parameters to default value, click the Reset button.


 Blur/sharpen

This function will make an image appear blurry or sharper depending on which method you choose.
This function accepts one parameter to control the output. When a selection exists, the function will be applied to that area only.


 Decrease Bits Per Pixel

Decreasing color depth is also known as quantization. It is the process of choosing n number of colors that closely resemble the original image. PicWalker implements 3 different methods of quantization: Octree, Neural-Net and Wu algorithms.

In addition to the quantization, using error diffusion typically can give better result. PicWalker uses Floyd-Steinberg method for error diffusion.

"Measure error" option is given so you can check the result of the different methods. MSE stands for mean squared error which is the average of errors (squared) for all the pixels in the output when compared to the source. The smaller the MSE is, the more similar the result to the original.


Dithering is the process of converting a color image to black & white image.
PicWalker implements 4 different dithering methods. In all methods, the original image is converted to gray scale first.
Average dithering
This method takes the average value of all the pixels, and uses that as the threshold to determine whether a pixel should be plotted black or white.
Floyd-Steinberg dithering
This is the most commonly used method to produce good dither output. It diffuses the errors at each pixel location to its 4 neighbors
Ordered dithering
This method uses a fixed 4x4 matrix as threshold to decide whether a pixel should be plotted black or white.
Victor Ostromoukov
This is a variation of Floyd-Steinberg method developed by Victor Ostromoukov. It disperses the errors to 3 neighbors instead of 4. It uses a table of precomputed coefficients for each gray intensity level instead of the same coefficients as Floyd-Steinberg's. More detail can be obtained from http://www.iro.umontreal.ca/~ostrom.


 Edge Detection

You can try from 3 different edge detectors: Canny, Sobel and LaPlace.

Canny's method will produce a true edge image (black & white) while the other two create gray scale image. Canny's edge detector accepts 3 parameters: blur radius, high and low thresholds.
The blur process is the same as in Blur/Sharpen function.
High and low thresholds can be adjusted to get better result.

For more info on edge detectors, you can visit Bill Green's edge detection tutorial at http://www.pages.drexel.edu/~weg22/index.html.


 Resample

In this dialog you can set the new desired dimension, and choose the filter for resizing.
There are several filters to choose from, the fastest one is point filter.
Triangle filter is pretty fast and still gives good result.
I find Lanczos filter to give best result for shrinking an image, and Mitchell filter to create more desirable image for enlarging.
You can click Apply button to preview the result, and change the filter if it is not satisfactory.

Preserve aspect ratio check box can be used if you want to maintain same ratio between width & height.
The program automatically changes width/height when you change one of the value.

PS: In batch convert, preserve aspect ratio means the width & height specified are to be used as maximum width & height when the program resize an image while preserving its ratio.
From the advanced option dialog, you can also choose to use these resampling filters when you zoom in/out.


 Display adjustment
Docking windows
The toolbars and windows in PicWalker are docking windows, that means they can either be docked in the main window or set as separate windows.
To move a window, click on the title bar (or left side bar for toolbars) and drag it. You may hold down the control key to prevent docking.
Windows 2000/XP only: when a window is not docked, it may be set as transparent window. This option is accessible by right clicking its title bar.

Zoom
The zoom functions are available from the View menu and context menu. You can adjust the amount of zoom in/out from the Options menu.

In edit mode, you can also zoom in the selection area by clicking inside of it.

Fit to width/height option adjusts the scale to the window size.
If you prefer, the program also has the option to enlarge smaller images to fit the window size.

If you want a better quality image, you can change the resampling filter from the Advanced Option menu.

Alignment
PicWalker allows images to be aligned to the left side, center or the right side.
This alignment option is stored in the configuration file for each directory and archive file, so you can have different alignment for each location.
Alignment can be set from the View menu or from the hand buttons on the second toolbar.


 Batch Convert
Batch convert can be used if you need to save several files to a different format or if you want to apply one or more edit functions to those files.
This tool only operates on the current list of files.
To use it, go to Tools menu and choose "Batch convert".

When you start this function, PicWalker will be set to edit mode.
In this dialog you need to select the files to be processed from the source list.
Then, you must specify a directory to save the new files in.
If you want to change the file names to use sequence number, click on the "use pattern" radio button, otherwise the program will use the original file name without its extension as the target name.
If you use pattern, the first sequence of #'s will be changed to the sequence number of the file.
This number is the index of the files that are selected into the input list.

Then, you need to specify the save format, and its parameters if applicable.

When everything is satisfactory, click the "Next step" button to select functions to be applied on the images.

When you reach this dialog, the program will open the first file in the input list, so you can preview the function (if it has a dialog box).
All of the edit functions available in PicWalker can be chosen. If a function uses dialog window, the same dialog will be shown.
Double click a function name to add it to the list.

When you are ready, click the "Proceed" button to process the files.

The image above shows the batch convert in progress. Click on the area you want to know more about.


 Favorites
The favorite menu can be used to keep track of the directories that you often browse.

Add to favorites option adds the current directory to the favorite list.
It invokes the same window as the second option (Organize favorites).

The fields are editable by clicking on them.
The name for a favorite item is limited to 50 characters.
Favorites are saved in a file named pwalk.fav .


 Printing
The print function is located under File menu.
If the application is not in edit mode, you can also select the pages to be printed.

PicWalker allows you to preview the print output, and adjust the location/size of the output.

You can choose between mm, cm and inch as the unit of measurement.
Print Sizes
Fit Page | Fit the image, so it fills the page up to its margins, while maintaining the aspect ratio
Fill Page | Fit the image to fill the entire page up to its margins
Actual Size | Scale the image to make a print output that has similar size to the image on the screen
Scale | Scale the image in x & y directions according to user input
Custom | Use the dimension and unit specified by user
Print Position
Choose between centered, and user specified position.
You can also use the mouse to drag the preview image, to adjust its size and position.


 Search duplicate files
This tool is useful to find duplicate files within a directory or across several directories.
This function can search all file types, or just the picture files.
It can be found under the Tools menu.

When you start this function, PicWalker will add the current directory as one of the directories to be searched.
You can add more by typing the directory name and clicking Add button, or by clicking Browse button to find the folder.
You can also specify to search recursively into the sub-directories.

When you are satisfied with your selection, click the Proceed button to start the search. You can cancel it at any time.

When the program finds duplicate files, it will show them in a new list, sorted by file size. To easily identify the duplicate files, they are grouped using 4 different colors.
To open the file, double click the file name.
You can also right click the list to go to the directory where the file is.

You can leave the window open, and do something else in PicWalker.


 View modes
Continuous pages
In this view mode, PicWalker loads the next 2 consecutive images and display them right below the current image.
As you scroll down/up, the next image is retrieved in the background.

If you like you can also change the orientation to place the images horizontally.
Center alignment behaves like left alignment with this orientation.
Right alignment reverses the order of the files.

Single page
Displays only one image at a time.

Slide show
Automatically loads the files sequentially after a period of time.
You can change the sort order, fitting, speed and transition effect from the Tools->Slide Show Options menu.
The toolbars are hidden in this mode, and all extra windows are disabled.

Full screen
This mode makes the application occupies the whole screen, and the menu toolbar is hidden.

Edit mode
This mode is enabled by choosing Edit current image option from the Edit menu, or by pasting a bitmap clipboard content.
In edit mode several functions are available to alter the image.

The default mouse click operation is to select a region of the picture to be copied to the clipboard.
You can also adjust the selection rectangle using the keyboard.
Hold down shift+arrow to resize or control+arrow to move the selection.

Explorer mode
When this mode is enabled, you have access to the list of files or thumbnails. The directory tree window is enabled by default in this mode.
You can delete or rename files from the list. Sort order can also be changed here.


 Explorer view

In this view, you can see the sub-directories, archive and image files.
You can rename, or delete files and also change the sorting order here.

You can change the view to: thumbnails, details, list, icons or tiles.
In detail mode, you can change the sorting order by clicking the column header.
When the view is set to display thumbnails, you also have the options to hide/show the fields, and to customize the thumbnail size.

The resampling filter to create thumbnail can also be changed. Go to Mode menu and select Custom to change it.
All the filters from the Resample command can be found here.

The directory tree on the left side can be toggled on/off from the View menu. It can also be displayed when you are not in explorer view.


 Plug-ins
Plug-ins enable developers to extend the functionality of the application without modifying the core program file.

There are 2 types of plug-ins for PicWalker: decoder/encoder and image manipulation.
Plug-ins must be stored in \plugins directory within the directory where the main program executable resides.

PicWalker comes with 1 plug-in: jasper.dll, a codec for JPEG2000 file format.
You can also find a plug-in for reading Adobe Photoshop's Filter Factory files at http://www.oma-penny.com/pwalk_plug.htm.

The source code for both plug-ins can be found at the above URL. You can use it to learn how to write your own plug-ins.


 Filter Factory

Filter factory is a plug-in for Adobe Photoshop made by Joe Ternasky.
It allows users to create their own image filters easily.

There have been a lot of user defined filters created using Filter Factory and can be found on the web, thus creating a large selection of filters you can choose from. One place to find them is http://stevesdesktopphotography.com/plugins.htm

The plug-in code to read filter factory file originated from the source code made by Jens Ch. Restemeier (www.geocities.com/SiliconValley/Way/3340/).
It is able to read compiled and uncompiled FilterFactory plug-ins (*.afs, *.txt and *.8bf), and FilterFactory Libraries (*.ffl).

Like the blur function, this plug-in supports selection, so you can select an area of the image you want to apply the filter to.

Before you can use this function, first you need to have the filter factory files (can be found at the above web site). Then click on "Find more filters" to browse to the directory where the files are. You will be allowed to search sub-directories if they exist.
When the program finds the filters, it will add them to the list.

As you navigate through the list, the preview window will be updated. Click Apply to see the filter applied to the image. It may look different than what the preview was, because the filters are affected by the coordinates (x and y values).

The filter list will be saved for future use when you exit the application.


 Extra windows
Directory tree

Displays the directories as a tree structure. You can change directory quickly using this window.
It can be enabled from the View menu, or from a shortcut key.

Picture list

This window lists all the picture files currently available. You can double click the file name to open the picture.
The list orientation can be changed by right clicking on the window.

The windows can be docked or set as floating windows. In Windows 2000/XP, when a window is not docked, it can be made transparent by right clicking the title bar and choosing the option.


 Contribute
PicWalker is still under continuous development. Your contribution will be greatly appreciated.
If you like this program, please register at the home web site. Registration cost is US $10.

You can also contribute by reporting bugs, sending me your critics, suggestions, or source code that you think can improve the program.

Thank you.


 Copyrights
Some parts of this program use the source code made available freely by other authors. Listed below are the copyright notices that needed to be included to use those codes.
Other codes used are listed in the About box of the application.
* LibTIFF
* Copyright (c) 1988-1997 Sam Leffler
* Copyright (c) 1991-1997 Silicon Graphics, Inc.
*
* Permission to use, copy, modify, distribute, and sell this software and
* its documentation for any purpose is hereby granted without fee, provided
* that (i) the above copyright notices and this permission notice appear in
* all copies of the software and related documentation, and (ii) the names of
* Sam Leffler and Silicon Graphics may not be used in any advertising or
* publicity relating to the software without the specific, prior written
* permission of Sam Leffler and Silicon Graphics.
*
* THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
* EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
* WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
*
* IN NO EVENT SHALL SAM LEFFLER OR SILICON GRAPHICS BE LIABLE FOR
* ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
* OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
* WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF
* LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
* OF THIS SOFTWARE.

* NeuQuant Neural-Net Quantization Algorithm
* ------------------------------------------
*
* Copyright (c) 1994 Anthony Dekker
*
* NEUQUANT Neural-Net quantization algorithm by Anthony Dekker, 1994.
* See "Kohonen neural networks for optimal colour quantization"
* in "Network: Computation in Neural Systems" Vol. 5 (1994) pp 351-367.
* for a discussion of the algorithm.
* See also  http://members.ozemail.com.au/~dekker/NEUQUANT.HTML
*
* Any party obtaining a copy of these files from the author, directly or
* indirectly, is granted, free of charge, a full and unrestricted irrevocable,
* world-wide, paid up, royalty-free, nonexclusive right and license to deal
* in this software and documentation files (the "Software"), including without
* limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
* and/or sell copies of the Software, and to permit persons who receive
* copies from any such party to do so, with the only requirement being
* that this copyright notice remain intact.

Windows is a registered trademark of Microsoft


 Limitation
PicWalker does not support transparency yet. The transparent color will be displayed as black.

When you open an image file that contains multiple images (.ico, .gif, .tif), PicWalker only displays the first image. As such, animation is not supported.


Version history

4.2 released 10/10/2004
Added support for archive within archive
Added option to view directory structures of archive files
Added scanner function
Added option to change the file filter for Open File dialog
Decoder added: IFF
Encoder added: GIF, IFF, XBM, XPM
Added support for ACE, CAB and TAR archives
Added random jump option
Added export toolbar function to customize the toolbar
Allowed switching to different window in full screen mode
Drop down list is now jumpable

Bug fix:
Unclickable menu when window width is too small
BMP decoder for RLE compression

4.1 released 7/7/2004
Explorer view was improved by merging the thumbnails and file list.
Added option to not show archive files content in explorer view.
Added option to generate thumbnail after loading an image.
Added docking windows capability.
Added support for SGI and Photoshop files.
Renamed File list window to Picture list, and removed delete functions from it.

Bug fixes:
Fixed crash that could happen when the system ran out of memory while opening a large image.
Fixed clipboard pasting error for images with 256 colors or less.
Fixed error in the set as wallpaper function.

4.0 released 6/6/2004
Decoder added: PBM, PGM, PPM.
Decoder removed: EMF, because the previous code always requires to read the whole file at once.
Config file is changed to be more compact, and easier to parse.
Continuous pages can be shown horizontally.
Added more edit functions: color correction, blur/sharpen, edge detector, resize, decrease/increase BPP, dither, swap RGB.
Better quality zoom is possible with resampling.
Added option to paste insert image.
Now supports multiple undo and redo.
Added sorting and printing option.
Added slide show with transition effects.
Moved the thumbnail window into the main window (explorer view).
Thumbnail size is user customizable now.
Batch convert and manipulate.
Support for password protected zip/rar.
Added function to search duplicate files.
Added tips in intro screen.
Horizontal scrolling in continuous pages mode is now limited to the maximum for the current list of images.
Added separator between images in continuous pages mode.
PicWalker can now run with multiple windows.
The image now looks better in 256 color display mode.
PicWalker now saves PNG files using the correct parameters.
Added support for plug-ins.

Bug fixes:
Fixed window position when switching to full screen in multi-monitor system.
Page numbering is now correct when you scroll in continuous pages mode.
Corrected file extension association.
All the bugs I found that can crash the program has been eliminated.

3.9 released 7/7/2003
Added GIF and TIFF support.
Added the ability to cutomize the file filter.
Added an option to include sub-directories in the file list drop down.
Scrolling with the keyboard is smooth, now, and adjustable.
The Loading of directory tree when there are many files is faster now.
Added option to hide thumbnail and file list windows in full screen.
Modified the toolbar and menu window.
Changed the mouse wheel behavior in slide show.
Changed the help file to HTML help.
Updated UnRAR library to the latest version.

Bug fixes:
Fixed crash bug when selecting outside the image in edit mode
Fixed occasional window refresh problem.
Fixed recursive sorting when more than one level of subdirectories exists.
Fixed slide show up problem with timing when in single page mode.
Fixed most recent file loading at startup, when the last file opened is from a recursive listing.
Fixed thumbnail window not showing anything the first time it is displayed.
Fixed error when deleting temporary files.

3.1 released 5/5/2003
Added alignment option, default to center alignment.
Added drop down list for the content of archive files.
Added directory tree view option.
Last file opened in an archive file is now remembered.
File list window dimension is remembered.
Alignment setting is retained for archive files and directories, up to 200 entries each.
Completed option for mouse shortcuts.
Add to favorite option now uses the same window as Organize favorite.
Drop down lists were changed to resize to fit the text content.
Added fit to height option to complement fit to width.
Added option to reopen the last opened file at startup.
Added progress dialog for zip file extraction.

Fixed: sorting order when listing directory content recursively.
Fixed: crash bug when opening different zip files too quickly.
Fixed: occasional missing file in drop down list.

3.0 released 4/4/2003
Added clipboard copy/paste function.
Added flip and rotate image functions.
Continuous pages mode is more responsive, by loading multiple images in the background.
Mouse drag is now customizable.
Mouse drag now locks the cursor position, to minimize user effort.
Recent directories history now keeps track of last opened file.
Added option to fit to width smaller images.
Added Save as JPG option.
Scrollbar is now optional.
Added option to use mouse wheel to start slide show.

2.9 released 3/7/2003
Removed usage of Internet Explorer and MFC library.
Added synchronization of the file list selection as you navigate.
Much better thumbnail view that runs in separate thread.
More intuitive dialog to setup shortcut keys.
Loading of large file list can now be canceled.
Images in zip file that is less than 1 MB is loaded in memory, instead of using temporary file.
Added Save as PNG & BMP.
Added basic functionality to extract files.
A very much smoother continuous page.
Fit width option now works properly in all mode.
Fixed file association to override Windows' Open With selection.
Whenever possible, error messages are displayed as part of the screen and does not require you to confirm it.

2.8 released 2/10/2003
Added internal support for rar file, no longer uses WinRAR.
Added continuous page mode to display files in one screen.
Added optional help file.

2.7 released 12/30/2002
Added internal support for zip file, WinRAR can still be used to open other archive files.
Favorites menu can now be used to keep your favorite folders instead of IE favorites.
Bug fix: Corrected file type association that wiped out other association not currently using PicWalker.

2.6 released 12/7/2002
Added menu option to open prev/next archive file.
Added option to associate file type with PicWalker.
File list can now be scrolled vertically.

2.5 released 11/11/2002
Added option to show scroll bar in full screen mode, to correct problem with Windows 98.
Added floating file list option (with transparency in Windows 2K and later).
Reduced flickering.
Rearranged some menu options.

2.1 released 11/9/2002
Fixed the bugs with Windows 98, such as double clicking and picture dragging.
Preview function has also been reworked.
All menu shortcuts are fully customizable.
New functions added: full screen and zoom.

1.0 released 10/29/2002
Initial version, with functions to create catalog of picture files in an archive / folder.


 Contact
Homepage
If you want to get the latest information about PicWalker, please visit http://www.oma-penny.com

Feedback
Please send any bug report, suggestion, and comment to support@oma-penny.com